function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
export var extractDirectedRelation = function(config, direction) {
    var split = {
        here: config["vertex".concat(direction == "A->B" ? "A" : "B")].anchor.split("."),
        there: config["vertex".concat(direction == "A->B" ? "B" : "A")].anchor.split(".")
    };
    return {
        here: {
            collection: split.here[0],
            list: split.here[1],
            field: split.here[2]
        },
        there: {
            collection: split.there[0],
            list: split.there[1],
            field: split.there[2]
        }
    };
};
export var getId = function(entry) {
    return typeof entry == "string" ? entry : entry ? entry.id : undefined;
};
export var getList = function(config, direction, data) {
    return data[extractDirectedRelation(config, direction).here.list];
};
var getRelationMeta = function(entry, field) {
    var relationMeta = Object.assign({}, entry);
    delete relationMeta[field];
    delete relationMeta["id"];
    return relationMeta;
};
export var couple = function() {
    var _ref = _async_to_generator(function(docHere, relationEntries, config, direction, req, mode, context) {
        var _extractDirectedRelation, here, there, docHereId, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, entryHere, docThereId, relationMetaHere, newEntryThere, entriesThere, matches, updateNeeded, _context_depth, depth, e, err;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    _extractDirectedRelation = extractDirectedRelation(config, direction), here = _extractDirectedRelation.here, there = _extractDirectedRelation.there;
                    docHereId = getId(docHere);
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    if (!docHereId) return [
                        3,
                        12
                    ];
                    _state.label = 1;
                case 1:
                    _state.trys.push([
                        1,
                        10,
                        11,
                        12
                    ]);
                    _iterator = relationEntries[Symbol.iterator]();
                    _state.label = 2;
                case 2:
                    if (!!(_iteratorNormalCompletion = (_step = _iterator.next()).done)) return [
                        3,
                        9
                    ];
                    entryHere = _step.value;
                    docThereId = getId(entryHere[here.field]);
                    if (!docThereId) return [
                        3,
                        8
                    ];
                    relationMetaHere = getRelationMeta(entryHere, here.field);
                    newEntryThere = _object_spread(_define_property({}, there.field, docHereId), relationMetaHere);
                    _state.label = 3;
                case 3:
                    _state.trys.push([
                        3,
                        7,
                        ,
                        8
                    ]);
                    return [
                        4,
                        req.payload.findByID({
                            collection: there.collection,
                            id: docThereId,
                            depth: 2
                        })
                    ];
                case 4:
                    entriesThere = _state.sent()[there.list];
                    matches = entriesThere.filter(function(entryThere) {
                        return getId(entryThere[there.field]) == docHereId;
                    });
                    updateNeeded = mode == "decoupling" ? matches.length > 0 : matches.length != 1 ? true : !deepComparison(relationMetaHere, getRelationMeta(matches[0], there.field));
                    depth = (_context_depth = context.depth) !== null && _context_depth !== void 0 ? _context_depth : 0;
                    if (!(updateNeeded && depth < 1)) return [
                        3,
                        6
                    ];
                    return [
                        4,
                        req.payload.update({
                            collection: there.collection,
                            id: docThereId,
                            data: _define_property({}, there.list, _to_consumable_array(entriesThere.filter(function(entry) {
                                return getId(entry[there.field]) != docHereId;
                            }).map(function(entry) {
                                entry[there.field] = getId(entry[there.field]);
                                return entry;
                            })).concat(_to_consumable_array(mode == "decoupling" ? [] : [
                                newEntryThere
                            ]))),
                            context: _object_spread_props(_object_spread({}, context), {
                                depth: depth + 1
                            })
                        })
                    ];
                case 5:
                    _state.sent();
                    _state.label = 6;
                case 6:
                    return [
                        3,
                        8
                    ];
                case 7:
                    e = _state.sent();
                    console.log(e);
                    return [
                        3,
                        8
                    ];
                case 8:
                    _iteratorNormalCompletion = true;
                    return [
                        3,
                        2
                    ];
                case 9:
                    return [
                        3,
                        12
                    ];
                case 10:
                    err = _state.sent();
                    _didIteratorError = true;
                    _iteratorError = err;
                    return [
                        3,
                        12
                    ];
                case 11:
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                    return [
                        7
                    ];
                case 12:
                    return [
                        2
                    ];
            }
        });
    });
    return function couple(docHere, relationEntries, config, direction, req, mode, context) {
        return _ref.apply(this, arguments);
    };
}();
export var deepComparison = function(object1, object2) {
    var keys1 = Object.keys(object1);
    var keys2 = Object.keys(object2);
    if (keys1.length !== keys2.length) return false;
    if (keys1.filter(function(key) {
        return !keys2.includes(key);
    }).length > 0) return false;
    var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
    try {
        for(var _iterator = keys1[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
            var key = _step.value;
            var val1 = object1[key];
            var val2 = object2[key];
            var deepen = val1 != null && typeof val1 === "object" && val2 != null && typeof val2 === "object";
            if (deepen && !deepComparison(val1, val2) || !deepen && val1 !== val2) return false;
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally{
        try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
            }
        } finally{
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
    return true;
};

//# sourceMappingURL=helpers.js.map