function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
import { couple, deepComparison, extractDirectedRelation, getId, getList } from "./helpers";
export var afterListChange = function(config, direction) {
    return function() {
        var _ref = _async_to_generator(function(param) {
            var originalDoc, value, previousValue, req, context, there, _previousValue_filter, deletedEntries;
            return _ts_generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        originalDoc = param.originalDoc, value = param.value, previousValue = param.previousValue, req = param.req, context = param.context;
                        if (!(value && originalDoc && value !== previousValue)) return [
                            3,
                            3
                        ];
                        if (previousValue && deepComparison(value, previousValue)) return [
                            2,
                            null
                        ];
                        there = extractDirectedRelation(config, direction).there;
                        deletedEntries = (_previousValue_filter = previousValue === null || previousValue === void 0 ? void 0 : previousValue.filter(function(oldEntry) {
                            return value.filter(function(newEntry) {
                                return getId(oldEntry[there.field]) === getId(newEntry[there.field]);
                            }).length == 0;
                        })) !== null && _previousValue_filter !== void 0 ? _previousValue_filter : [];
                        return [
                            4,
                            couple(originalDoc, deletedEntries, config, direction, req, "decoupling", context)
                        ];
                    case 1:
                        _state.sent();
                        return [
                            4,
                            couple(originalDoc, value, config, direction, req, "recoupling", context)
                        ];
                    case 2:
                        _state.sent();
                        _state.label = 3;
                    case 3:
                        return [
                            2,
                            null
                        ];
                }
            });
        });
        return function(_) {
            return _ref.apply(this, arguments);
        };
    }();
};
export var afterDocumentDelete = function(config, direction) {
    return function() {
        var _ref = _async_to_generator(function(param) {
            var doc, req, context;
            return _ts_generator(this, function(_state) {
                doc = param.doc, req = param.req, context = param.context;
                return [
                    2,
                    couple(doc, getList(config, direction, doc), config, direction, req, "decoupling", context)
                ];
            });
        });
        return function(_) {
            return _ref.apply(this, arguments);
        };
    }();
};

//# sourceMappingURL=hooks.js.map